#if !defined(__fnc_mdic_h)              // Sentry, use file only if it's not already included.
#define __fnc_mdic_h

/*  Project fancy_ed
    Terry Richards Software
    Copyright  1994. All Rights Reserved.

    SUBSYSTEM:    fancy_ed.exe Application
    FILE:         fnc_mdic.h
    AUTHOR:       Terry Richards


    OVERVIEW
    ========
    Class definition for fancy_edMDIClient (TMDIClient).      
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include "fncy_dap.rh"            // Definition of all resources.


//{{TMDIClient = fancy_edMDIClient}}
class fancy_edMDIClient : public TMDIClient {
public:
    int                     ChildCount;                 // Number of child window created. 

    fancy_edMDIClient(TModule* module = 0);
    virtual ~fancy_edMDIClient ();

    void OpenFile (const char *fileName = 0);

private:
    void LoadTextFile ();

//{{fancy_edMDIClientVIRTUAL_BEGIN}}
protected:
    virtual void SetupWindow ();
//{{fancy_edMDIClientVIRTUAL_END}}

//{{fancy_edMDIClientRSP_TBL_BEGIN}}
protected:
    void CmFileNew ();
    void CmFileOpen ();
    void CmFilePrint ();
    void CmFilePrintSetup ();
    void CmFilePrintPreview ();
    void CmPrintEnable (TCommandEnabler &tce);
    void EvDropFiles (TDropInfo);
//{{fancy_edMDIClientRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(fancy_edMDIClient);
};    //{{fancy_edMDIClient}}


#endif                                      // __fnc_mdic_h sentry.
